using System;
using System.Net;
using Bespoke.Common.Osc;

namespace Client
{
	class Program
	{
		static void Main(string[] args)
		{
            sOscServer = new OscServer(TransportType.Tcp, ServerAddress, ServerPort);
			sOscServer.RegisterMethod(AliveMethod);
			sOscServer.MessageReceived += new OscMessageReceivedHandler(sOscServer_MessageReceived);

			sOscServer.Start();

			Console.WriteLine("OSC Client: " + sOscServer.TransmissionType.ToString());
			Console.WriteLine("Press any key to exit.");
			Console.ReadKey();
			sOscServer.Stop();
		}

		static void sOscServer_MessageReceived(object sender, OscMessageReceivedEventArgs e)
		{
			Console.WriteLine(string.Format("Message Received [{0}]: {1}", e.Message.SourceEndPoint.Address, e.Message.Address));
		}

        private static readonly IPAddress ServerAddress = IPAddress.Parse("127.0.0.1");
        //private static readonly IPAddress ServerAddress = IPAddress.Parse("224.25.26.27");
		private static readonly int ServerPort = 5103;
		private static readonly string AliveMethod = "/osctest/alive";

		private static OscServer sOscServer;
	}
}
