﻿Module Client

	Sub Main()
		sOscServer = New OscServer(TransportType, ServerAddress, ServerPort)
		sOscServer.RegisterMethod(AliveMethod)

		sOscServer.Start()

		Console.WriteLine("OSC Client: " + sOscServer.TransmissionType.ToString())
		Console.WriteLine("Press any key to exit.")
		Console.ReadKey()
		sOscServer.Stop()

	End Sub

	Sub sOscServer_MessageReceived(ByVal sender As Object, ByVal e As OscMessageReceivedEventArgs) Handles sOscServer.MessageReceived
		Console.WriteLine(String.Format("Message Received [{0}]: {1}", e.Message.SourceEndPoint.Address, e.Message.Address))
	End Sub

	Private ReadOnly TransportType As TransportType = TransportType.Udp
	Private ReadOnly ServerAddress As IPAddress = IPAddress.Parse("127.0.0.1")
	Private ReadOnly ServerPort As Integer = 5103
	Private ReadOnly AliveMethod As String = "/osctest/alive"

	Private WithEvents sOscServer As OscServer
End Module
