﻿Module Server

	Sub Main()
		sSendMessages = True

		If TransportType = TransportType.Tcp Then
			sOscClient = New OscClient(Destination.Address, Destination.Port)
			sOscClient.Connect()
		End If

		sMessage = New OscMessage(New IPEndPoint(IPAddress.Loopback, DestinationPort), AliveMethod, sOscClient)
		
		Dim serverThread As Thread = New Thread(AddressOf RunWorker)
		serverThread.Start()

		Console.WriteLine("OSC Transmitter: " + TransportType.ToString())
		Console.WriteLine("Press any key to exit.")
		Console.ReadKey()
		sSendMessages = False
		serverThread.Join()

		If TransportType = TransportType.Tcp Then
			sOscClient.Close()
		End If
	End Sub

	Sub RunWorker()

		While sSendMessages
			Select Case TransportType
				Case TransportType.Udp
					sMessage.Send(Destination)

				Case TransportType.Tcp
					sMessage.Send()
			End Select

			Thread.Sleep(1000)
		End While
	End Sub


	Private ReadOnly TransportType As TransportType = TransportType.Udp
	Private ReadOnly DestinationAddress As IPAddress = IPAddress.Parse("127.0.0.1")
	Private ReadOnly DestinationPort As Integer = 5103
	Private ReadOnly Destination As IPEndPoint = New IPEndPoint(DestinationAddress, DestinationPort)
	Private ReadOnly AliveMethod As String = "/osctest/alive"

	Private sSendMessages As Boolean
	Private sMessage As OscMessage
	Private sOscClient As OscClient
End Module
